wxWidgets: wxEvent Class Reference

| Version: 3.0.5

Public Member Functions | Protected Attributes | List of all members
wxEvent Class Referenceabstract
Class List by Category » Events

`#include </home/Hamis/wxwidgets/wxWidgets3.0/wxWidgets3.0-3.0.5.1-2.x86_64/src/wxWidgets-3.0.5.1/interface/wx/event.h>`

Inheritance diagram for wxEvent:
[legend]

## Detailed Description

An event is a structure holding information about an event passed to a callback or member function.

wxEvent used to be a multipurpose event object, and is an abstract base class for other event classes (see below).

For more information about events, see the Events and Event Handling overview.

wxPerl Note: In wxPerl custom event classes should be derived from `Wx::PlEvent` and `Wx::PlCommandEvent`.

##

Library: wxBase

<>< =''>:</>&;&;< =''>\ </></>

See also
  wxCommandEvent, wxMouseEvent

## Public Member Functions
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor. More...
virtual wxEvent * | Clone () const =0
| Returns a copy of the event. More...
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any. More...
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`. More...
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event. More...
int | GetId () const
| Returns the identifier associated with this event, such as a button command id. More...
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler. More...
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise. More...
long | GetTimestamp () const
| Gets the timestamp for the event. More...
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false. More...
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation). More...
void | SetEventObject (wxObject *object)
| Sets the originating object. More...
void | SetEventType (wxEventType type)
| Sets the event type. More...
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id. More...
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event. More...
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0. More...
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns. More...
int | StopPropagation ()
| Stop the event from propagating to its parent window. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...

## Protected Attributes
int | m_propagationLevel
| Indicates how many levels the event can propagate. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...

## Constructor & Destructor Documentation

## ◆ wxEvent()

wxEvent::wxEvent | ( | int | id = `0`,
|  | wxEventType | eventType = `wxEVT_NULL`
| ) |  |

Constructor.

Notice that events are usually created by wxWidgets itself and creating e.g. a wxPaintEvent in your code and sending it to e.g. a wxTextCtrl will not usually affect it at all as native controls have no specific knowledge about wxWidgets events. However you may construct objects of specific types and pass them to wxEvtHandler::ProcessEvent() if you want to create your own custom control and want to process its events in the same manner as the standard ones.

Also please notice that the order of parameters in this constructor is different from almost all the derived classes which specify the event type as the first argument.

Parameters

  id | The identifier of the object (window, timer, ...) which generated this event.
  eventType | The unique type of event, e.g. `wxEVT_PAINT`, `wxEVT_SIZE` or `wxEVT_BUTTON`.

## Member Function Documentation

## ◆ Clone()

virtual wxEvent* wxEvent::Clone | ( |  | ) | const
| pure virtual

Returns a copy of the event.

Any event that is posted to the wxWidgets event system for later action (via wxEvtHandler::AddPendingEvent, wxEvtHandler::QueueEvent or wxPostEvent()) must implement this method.

All wxWidgets events fully implement this method, but any derived events implemented by the user should also implement this method just in case they (or some event derived from them) are ever posted.

All wxWidgets events implement a copy constructor, so the easiest way of implementing the Clone function is to implement a copy constructor for a new event (call it MyEvent) and then define the Clone function like this:

wxEvent *Clone() const { return new MyEvent(*this); }
wxEvent
An event is a structure holding information about an event passed to a callback or member function.
Definition: event.h:93
wxEvent::Clone
virtual wxEvent * Clone() const =0
Returns a copy of the event.

Implemented in wxThreadEvent, and wxWindowModalDialogEvent.

## ◆ GetEventCategory()

virtual wxEventCategory wxEvent::GetEventCategory | ( |  | ) | const
| virtual

Returns a generic category for this event.

wxEvent implementation returns `wxEVT_CATEGORY_UI` by default.

This function is used to selectively process events in wxEventLoopBase::YieldFor.

Reimplemented in wxThreadEvent.

## ◆ GetEventObject()

wxObject* wxEvent::GetEventObject | ( |  | ) | const

Returns the object (usually a window) associated with the event, if any.

## ◆ GetEventType()

wxEventType wxEvent::GetEventType | ( |  | ) | const

Returns the identifier of the given event type, such as `wxEVT_BUTTON`.

## ◆ GetEventUserData()

wxObject* wxEvent::GetEventUserData | ( |  | ) | const

Return the user data associated with a dynamically connected event handler.

wxEvtHandler::Connect() and wxEvtHandler::Bind() allow associating optional `userData` pointer with the handler and this method returns the value of this pointer.

The returned pointer is owned by wxWidgets and must not be deleted.

Since
  2.9.5

## ◆ GetId()

int wxEvent::GetId | ( |  | ) | const

Returns the identifier associated with this event, such as a button command id.

## ◆ GetSkipped()

bool wxEvent::GetSkipped | ( |  | ) | const

Returns true if the event handler should be skipped, false otherwise.

## ◆ GetTimestamp()

long wxEvent::GetTimestamp | ( |  | ) | const

Gets the timestamp for the event.

The timestamp is the time in milliseconds since some fixed moment (not necessarily the standard Unix Epoch, so only differences between the timestamps and not their absolute values usually make sense).

Warning
  wxWidgets returns a non-NULL timestamp only for mouse and key events (see wxMouseEvent and wxKeyEvent).

## ◆ IsCommandEvent()

bool wxEvent::IsCommandEvent | ( |  | ) | const

Returns true if the event is or is derived from wxCommandEvent else it returns false.

Note
  exists only for optimization purposes.

## ◆ ResumePropagation()

void wxEvent::ResumePropagation | ( | int | propagationLevel | ) |

Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation).

## ◆ SetEventObject()

void wxEvent::SetEventObject | ( | wxObject * | object | ) |

Sets the originating object.

## ◆ SetEventType()

void wxEvent::SetEventType | ( | wxEventType | type | ) |

Sets the event type.

## ◆ SetId()

void wxEvent::SetId | ( | int | id | ) |

Sets the identifier associated with this event, such as a button command id.

## ◆ SetTimestamp()

void wxEvent::SetTimestamp | ( | long | timeStamp = `0` | ) |

Sets the timestamp for the event.

## ◆ ShouldPropagate()

bool wxEvent::ShouldPropagate | ( |  | ) | const

Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0.

## ◆ Skip()

void wxEvent::Skip | ( | bool | skip = `true` | ) |

This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns.

Without Skip() (or equivalently if Skip(false) is used), the event will not be processed any more. If Skip(true) is called, the event processing system continues searching for a further handler function for this event, even though it has been processed already in the current handler.

In general, it is recommended to skip all non-command events to allow the default handling to take place. The command events are, however, normally not skipped as usually a single command such as a button click or menu item selection must only be processed by one handler.

## ◆ StopPropagation()

int wxEvent::StopPropagation | ( |  | ) |

Stop the event from propagating to its parent window.

Returns the old propagation level value which may be later passed to ResumePropagation() to allow propagating the event again.

## Member Data Documentation

## ◆ m_propagationLevel

int wxEvent::m_propagationLevel
| protected

Indicates how many levels the event can propagate.

This member is protected and should typically only be set in the constructors of the derived classes. It may be temporarily changed by StopPropagation() and ResumePropagation() and tested with ShouldPropagate().

The initial value is set to either `wxEVENT_PROPAGATE_NONE` (by default) meaning that the event shouldn't be propagated at all or to `wxEVENT_PROPAGATE_MAX` (for command events) meaning that it should be propagated as much as necessary.

Any positive number means that the event should be propagated but no more than the given number of times. E.g. the propagation level may be set to 1 to propagate the event to its parent only, but not to its grandparent.